﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.Events;
using Infragistics.Windows.Editors;
using Infragistics.Windows;
using System.ComponentModel;
using System.Diagnostics;

namespace ColumnWidthIssue
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            dataGrid.FieldLayoutSettings.AutoGenerateFields = false;
            dataGrid.FieldLayoutInitialized += OnFieldLayoutInitialized;

            var persons = new List<Person>();
            for (int i = 0; i < 100; i++)
            {
                persons.Add(new Person
                {
                    Name = "Name " + i,
                    Address = "Street " + i
                });
            }

            dataGrid.DataSource = persons;
        }

        private void OnFieldLayoutInitialized(object sender, FieldLayoutInitializedEventArgs e)
        {
            var field = new Field
            {
                Label = "Name",
                Name = "Name",
                Width = new FieldLength(0, FieldLengthUnitType.Auto)
            };
            e.FieldLayout.Fields.Add(field);

            field = new Field
            {
                Label = "Address",
                Name = "Address",
                Settings = new FieldSettings
                {
                    AllowRecordFiltering = true,
                    EditorType = typeof(AddressEditor),
                    Width = new FieldLength(0, FieldLengthUnitType.Auto)
            

                }
            };
            e.FieldLayout.Fields.Add(field);
        }

        double myWidth = 0;

        private void dataGrid_EditModeStarting(object sender, EditModeStartingEventArgs e)
        {            
            myWidth = (e.Editor.ActualWidth);
        }

        private void dataGrid_EditModeStarted(object sender, EditModeStartedEventArgs e)
        {
            string tmp = e.Editor.Text;
            e.Editor.Text += "d";
            e.Editor.Text = tmp;
        }

        private void dataGrid_EditModeEnded(object sender, EditModeEndedEventArgs e)
        {
            e.Cell.Field.Width = new FieldLength(myWidth);
            e.Cell.Field.Width = new FieldLength(0, FieldLengthUnitType.Auto);
            dataGrid.FieldSettings.CellValuePresenterStyle = new Style(typeof(CellValuePresenter));
        }
    }

    public class Person
    {
        public string Name { get; set; }

        public string Address { get; set; }
    }
}
